<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Admin\Api;

use Admin\Common\Api;
use Base\Domain\Config as ConfigDomain;

/**
 * 配置模块
 */
class Config extends Api {

    public function getRules() {
        return array(
            'getList' => array(
                'configName' => array('name' => 'config_name', 'max' => 500, 'desc' => '待搜索的配置名称，精确匹配'),
                'configDesc' => array('name' => 'config_desc', 'desc' => '待搜索的配置描述说明，模糊匹配'),
                'page' => array('name' => 'page', 'type' => 'int', 'min' => 1, 'default' => 1, 'desc' => '第几页'),
                'perpage' => array('name' => 'perpage', 'type' => 'int', 'min' => 1, 'max' => 5000, 'default' => 10, 'desc' => '分页数量'),
            ),
            'addConfig' => array(
                'configName' => array('name' => 'config_name', 'require' => true, 'max' => 500, 'desc' => '配置名称，如：config_switch'),
                'configValue' => array('name' => 'config_value', 'require' => true, 'desc' => '待添加的配置值，可以是数字、字符串、文本等'),
                'configDesc' => array('name' => 'config_desc', 'default' => '', 'desc' => '配置描述说明'),
            ),
            'getConfig' => array(
                'configName' => array('name' => 'config_name', 'require' => true, 'max' => 500, 'desc' => '配置名称，如：config_switch'),
            ),
            'editConfig' => array(
                'configName' => array('name' => 'config_name', 'require' => true, 'max' => 500, 'desc' => '配置名称，如：config_switch'),
                'configValue' => array('name' => 'config_value', 'require' => true, 'desc' => '待更新的配置值，可以是数字、字符串、文本等'),
                'configDesc' => array('name' => 'config_desc', 'default' => '', 'desc' => '配置描述说明，不为空时进行更新'),
            ),
            'removeConfig' => array(
                'configName' => array('name' => 'config_name', 'require' => true, 'max' => 500, 'desc' => '配置名称，如：config_switch'),
            ),
        );
    }

    /**
     * 获取配置列表
     * @desc 获取配置列表，同时支持搜索功能。
     * @return int total 总数
     * @retun array items 配置列表
     * @return int items[].id ID
     * @return string items[].config_name 配置名称
     * @return string items[].config_desc 配置描述
     * @return string items[].config_value 配置值
     * @return string items[].add_time 添加时间
     */
    public function getList() {
        $domain = new ConfigDomain();
        return $domain->getList($this->configName, $this->configDesc, $this->page, $this->perpage);
    }
    
    /**
     * 添加配置
     * @desc 添加一份新配置
     * @return boolean is_add 是否添加成功，true为添加配置成功，false表示配置已存在，不能重复添加
     */
    public function addConfig() {
        $rs = array('is_add' => true);
        
        $domain = new ConfigDomain();
        $configQueryRs = $domain->getConfig($this->configName);
        if (empty($configQueryRs)) {
            $domain->addConfig($this->configName, $this->configValue, $this->configDesc);
        } else {
            $rs['is_add'] = false;
        }
        
        return $rs;
    }
    
    /**
     * 获取配置
     * @desc 获取已经存在的配置
     * @return string config_value 配置值，不存在时返回null
     */
    public function getConfig() {
        $rs = array('config_value' => null);
        
        $domain = new ConfigDomain();
        $configQueryRs = $domain->getConfig($this->configName);
        if (!empty($configQueryRs)) {
            $rs = $configQueryRs;
        }
        
        return $rs;
    }
    
    /**
     * 修改配置
     * @desc 以最新的配置覆盖原来的配置。
     * @return boolean is_edit 是否更新成功，true为更新成功，false无更新，或配置不存在
     */
    public function editConfig() {
        $rs = array('is_edit' => false);
        
        $domain = new ConfigDomain();
        $updateRows = $domain->editConfig($this->configName, $this->configValue, $this->configDesc);
        if ($updateRows > 0) {
            $rs['is_edit'] = true;
        }
        
        return $rs;
    }
    
    /**
     * 删除配置
     * @desc 删除一份配置
     @return boolean is_remove 是否删除成功，true为删除成功，false无删除，配置不存在
     */
    public function removeConfig() {
        $rs = array('is_remove' => false);
        
        $domain = new ConfigDomain();
        $deleteRows = $domain->removeConfig($this->configName);
        if ($deleteRows > 0) {
            $rs['is_remove'] = true;
        }
        
        return $rs;
    }
}
